/*----------------------------------------------------------------------------+
|   Copyright (C) 2004  Hsu-Ping Feng                                         |
|                                                                             |
|   This program is free software; you can redistribute it and/or modify      |
|   it under the terms of the GNU General Public License as published by      |
|   the Free Software Foundation; either version 2 of the License, or         |
|   (at your option) any later version.                                       |
|                                                                             |
|   This program is distributed in the hope that it will be useful,           |
|   but WITHOUT ANY WARRANTY; without even the implied warranty of            |
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
|   GNU General Public License for more details.                              |
|                                                                             |
|   You should have received a copy of the GNU General Public License         |
|   along with this program; if not, write to the Free Software               |
|                                                                             |
|   Foundation, Inc., 59 Temple Place, Suite 330,                             |
|   Boston, MA  02111-1307 USA                                                |
|                                                                             |
|                                                                             |
|   Author e-mail: spferng@ksts.seed.net.tw                                   |
+----------------------------------------------------------------------------*/
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include "fdisk.h"
#include "common.h"
#include "global.h"
#include "keymap.h"
#include "selemenu.h"

#define EMU_BAD_SIDE    (  0)

#if ( LANGUAGE_SELE != CHINESE )
    /*static sbyte *symbol[] = { "", "BB", "CC" }; */
    static sbyte blksign[] = { 178, 0 };
    static sbyte *symbol[] = { blksign, "B", "C" };
    static sbyte notFoundBad[]  = "No bad track found.";
    static sbyte badSideTitle[] = " Bad Cyl  Side";
    
    #define SAFE_AREA_MSG     "---------- Safe Area Table -----------"
    #define SAVE_RESULT_MSG   "Do you want to save result to file?"
    #define PROMPT_CHECK      "Are you sure to do surface check?"
    #define CHK_RANGE_FMT     "Checking area:  Cylinder  %lu - %lu"
    #define NON_CHK_BLK_MSG   "Not checked block"
    #define BAD_BLOCK_MSG     "Bad block"
    #define CHK_OK_BLK_MSG    "Checked block"
    #define CHECKING_MSG      "Being Checked block"
    #define BAD_SECT_NUM      "Bad Tracks:  0"
    #define BLOCK_INFO_FMT    " Block = %lu Sector"
    #define PRESS_ESC_TO_STOP "Press [Esc] to stop"
    #define FOUND_BAD_SECT    "Bad tracks found!"

    #define SERNO_TITLE       "No."
    #define START_CYL_TITLE   "Start"
    #define END_CYL_TITLE     "End"
    #define AREA_SIZE_TITLE   "Safe_Area_Size"

    #define BLK_PER_LINE      ( 60 /*76*/)
    #define SIGN_WIDTH        (  1)

#elif ( CHINESE_SELE == TRANDITION )
    static sbyte badSideTitle[] = "laϬW  Э";
    static sbyte *symbol[] = { "", "", "" };
    static sbyte notFoundBad[]  = "S  o { l a  y I";
    
    #define SAFE_AREA_MSG     "------------- wϰ -------------"
    #define SAVE_RESULT_MSG   "O _ N  G s  H"
    #define PROMPT_CHECK      "T w n i    H"
    #define CHK_RANGE_FMT     "ˬddG   %lu ϬW   %lu ϬW"
    #define NON_CHK_BLK_MSG   "հ϶"
    #define BAD_BLOCK_MSG     "la϶"
    #define CHK_OK_BLK_MSG    "wհ϶"
    #define CHECKING_MSG      "դ϶"
    #define BAD_SECT_NUM      "laϭyơG 0"
    #define BLOCK_INFO_FMT    " ϶ = %lu ϰ"
    #define PRESS_ESC_TO_STOP " [Esc]    "
    #define FOUND_BAD_SECT    "o { l a  y I"

    #define SERNO_TITLE       "s"
    #define START_CYL_TITLE   "ҩl"
    #define END_CYL_TITLE     ""
    #define AREA_SIZE_TITLE   "wϰeq"

    #define SIGN_WIDTH        (  2)
    #define BLK_PER_LINE      ( 30 /*38*/)

#elif ( CHINESE_SELE == SIMPLE )
    static sbyte badSideTitle[] = "laϬW  L";
    static sbyte *symbol[] = { "", "", "" };
    static sbyte notFoundBad[]  = "S  o { l a  y I";
    
    #define SAFE_AREA_MSG     "------------- wϰ -------------"
    #define SAVE_RESULT_MSG   "O _ N  G s  H"
    #define PROMPT_CHECK      "T w n i    H"
    #define CHK_RANGE_FMT     "ˬddG   %lu ϬW   %lu ϬW"
    #define NON_CHK_BLK_MSG   "հ϶"
    #define BAD_BLOCK_MSG     "la϶"
    #define CHK_OK_BLK_MSG    "wհ϶"
    #define CHECKING_MSG      "դ϶"
    #define BAD_SECT_NUM      "laϭyơG 0"
    #define BLOCK_INFO_FMT    " ϶ = %lu ϰ"
    #define PRESS_ESC_TO_STOP " [Esc]    "
    #define FOUND_BAD_SECT    "o { l a  y I"

    #define SERNO_TITLE       "s"
    #define START_CYL_TITLE   "ҩl"
    #define END_CYL_TITLE     ""
    #define AREA_SIZE_TITLE   "wϰeq"

    #define SIGN_WIDTH        (  2)
    #define BLK_PER_LINE      ( 30 /*38*/)

#else
    #error Language configure is not support!!!
#endif

/*=====================      a y   p =======================*/
#if EMU_BAD_SIDE
sword IsBadSide (dword cyl, dword side)
{
    #if 1
        return( (cyl == 35) && (side == 8)  || 
                (cyl == 60) && (side == 3)  ||
                (cyl == 68) && (side == 4)  ||
                (cyl == 79) && (side == 5)  ||
                (cyl == 81) && (side == 6)  ||
                (cyl == 83) && (side == 7)  ||
                (cyl == 350) && (side == 16) ||
                (cyl == 351) && (side == 1) ||
                (cyl == 600) && (side == 8)  ||
                (cyl == 700) && (side == 9)  ||
                (cyl == 800) && (side == 0)  ||
                (cyl == 1003) && (side == 23) ||
                (cyl == 1003) && (side == 40) ||
                (cyl == 1023) && (side == 125) );
    #else
        return(0);
    #endif /* 0 */
} /* end IsBadSide */

#endif /* end EMU_BAD_SIDE */


/*=====================   e        =======================*/
void Chk_Surface (dword start_cyl, dword end_cyl, SafeArea *safeArea)
{
    #define OK_BLK_NDX      (   0)
    #define BAD_BLK_NDX     (   1)
    #define CHK_BLK_NDX     (   2)
    #define TOTAL_ROW       (  14)
    #define X_BOUND         (BLK_PER_LINE * SIGN_WIDTH + 2)

    SafeArea  area;

    dword  box_side, count;
    dword  nBadSide, nBadCyl;
    dword  sector, side, cyl;
    sword  bSideCHK, bBadBLK, bBadSide, bBadCyl;
    sword  listY, nBox, x, y, i, j;
    sword  box_num = BLK_PER_LINE * TOTAL_ROW;
    sbyte  fname[43];
    FILE   *fptr = NULL;

    if ( YN_box(TALK_BOX, PROMPT_CHECK) == 0 )
        return;

    if ( YN_box(TALK_BOX, SAVE_RESULT_MSG) )
    {
        if ( !Input_Filename(fname, 42) || !Is_Overwrite(fname) )
        {
            Cancel_Box();
            return;
        } /* end if */

        if ( (fptr = new_fopen(fname, "w")) == NULL )
        {
            ShowError(8);
            return;
        } /* end if */

        new_fprintf(fptr, "%s\n================\n", badSideTitle);
    } /* end if */

    if ( safeArea )
    {
        memset(safeArea, 0, sizeof(SafeArea) * SAFE_AREA_NUM);
        memset(&area, 0, sizeof(SafeArea));
    } /* end if */

    /* g_Info.fd.clr_screen = TRUE;  */
    Redraw_Fdisk_Picture(TRUE);
    Clr_Block(2, 1, 54, 1);
    c_printXY(3, 2, CHK_RANGE_FMT, start_cyl, end_cyl);
    
    /*----- show bad side title -----*/
    ShowVertLine(X_BOUND+2, 3, 15, UP_MID_CHR, VERTICAL_CHR, VERTICAL_CHR);
    ShowHorizLine(X_BOUND+2, 5, 81-(X_BOUND+2), LF_MID_CHR, HORIZONTAL_CHR, RT_MID_CHR);
    ShowHorizLine(X_BOUND+2, 18, 81-(X_BOUND+2), LF_DN_CHR, HORIZONTAL_CHR, RT_MID_CHR);
    c_printXY(X_BOUND+3, 4, badSideTitle);

    /*----- get sides per block -----*/
    side = (end_cyl - start_cyl + 1) * (CUR_DK->lgeo.maxHead + 1);
    if ( side > box_num )
    {
        box_side = (side + (box_num - 1)) / box_num;
        box_num  = (sword)(side / box_side);
    }
    else
    {
        box_side = 1;
        box_num  = (sword)side;
    } /* end if */

    /*------ draw blocks -------*/
    c_textattr(NO_CHECK_COLOR);
    for ( x = box_num,  y = 4 ; x > 0 ; y++,  x-= BLK_PER_LINE )
    {
        c_gotoxy(3, y);
        Repeat_Str(symbol[OK_BLK_NDX], ((x >= BLK_PER_LINE) ? BLK_PER_LINE : x));
    } /* end for */
    
    /*------ show block note -------*/
    c_printXY(4, 20, symbol[OK_BLK_NDX]);
    c_printXY(6+SIGN_WIDTH, 20, NON_CHK_BLK_MSG);
    
    c_textattr(CHECKING_COLOR);
    c_printXY(4, 21, symbol[BAD_BLK_NDX]);
    c_textattr(DEFAULT_COLOR);
    c_printXY(6+SIGN_WIDTH, 21, BAD_BLOCK_MSG);
    
    c_printXY(30, 20, symbol[OK_BLK_NDX]);
    c_printXY(32+SIGN_WIDTH, 20, CHK_OK_BLK_MSG);
    
    c_printXY(30, 21, symbol[CHK_BLK_NDX]);
    c_printXY(32+SIGN_WIDTH, 21, CHECKING_MSG);
    
    c_printXY(55, 20, BAD_SECT_NUM);
    
    c_textattr(MESSAGE_COLOR);
    c_gotoxy(3, 19);
    Repeat_Char('-', 51);

    c_printf(BLOCK_INFO_FMT, box_side * CUR_DK->lgeo.maxSect);

    c_textattr(DEFAULT_COLOR);
    ShowMSG(PRESS_ESC_TO_STOP);
    
    ResetWorkDisk();
    
    /*------ surface check start -------*/
    count    = box_side;
    bBadBLK  = FALSE;
    bBadCyl  = FALSE;
    bBadSide = FALSE;
    bSideCHK = TRUE;
    nBadSide = 0;
    nBadCyl  = 0;
    nBox     = 0;
    listY    = 5;
    x        = 3;
    y        = 4;

    c_printXY(x, y, symbol[CHK_BLK_NDX]);
    for ( cyl = start_cyl ; cyl <= end_cyl ; cyl++ )
    {
        c_printXY(55, 21, "Cyl: %lu / %lu", cyl, end_cyl);

        for ( side = 0 ; side <= CUR_DK->lgeo.maxHead ; side++ )
        {
            /* c_printXY(55, 21, "Cyl: %lu, Side: %04lu", cyl, side);*/

#if EMU_BAD_SIDE
            /*------ Test Code -------*/
            if ( IsBadSide(cyl, side) )
            {
                bBadCyl = bBadBLK = bBadSide = TRUE;
                c_printXY(68, 20, " %lu", ++nBadSide);
            } /* end if */
#else
            if ( bSideCHK )
            {
                if ( chs_CheckWDK(side, cyl, 1, CUR_DK->lgeo.maxSect, NULL) )
                {
                    bSideCHK = TRUE;
                    bBadCyl  = bBadBLK = bBadSide = TRUE;
                } /* end if */
            }
            else
                for ( sector = 1 ; sector <= CUR_DK->lgeo.maxSect ; sector++ )
                    if ( c_kbhit() && (WaitKey() == ESC_KEY) )
                    {
                        if ( safeArea )
                            memset(safeArea, 0, sizeof(SafeArea) * SAFE_AREA_NUM);
                        User_Interrupt_Box();            /** ܨϥΪ̤_ **/
                        return;
                    }
                    else if ( chs_CheckWDK(side, cyl, sector, 1, NULL) )
                    {
                        bBadCyl = bBadBLK = bBadSide = TRUE;
                        break; 
                    } /* end if */
#endif /* 0 */

            /* ܵoͰDЭ */
            if ( bBadSide )
            {
                ResetWorkDisk();                               /** mϺ **/
                if ( listY >= 17 )
                    scroll_up(X_BOUND+3, 5, 78, 16, 1);
                else
                    listY++;
                c_printXY(X_BOUND+3, listY, "%7lu%7lu", cyl, side);
                c_printXY(68, 20, " %lu", ++nBadSide);
                bBadSide = FALSE;

                if ( fptr )
                    new_fprintf(fptr, "%7lu%7lu\n", cyl, side);
            } /* end if */

            /* øsw˴ block A */
            if ( --count <= 0 )
            {
                c_gotoxy(x, y);
                if ( bBadBLK )
                {
                    bBadBLK = FALSE;
                    c_textattr(CHK_ERR_COLOR);
                    c_printf(symbol[BAD_BLK_NDX]);
                    c_textattr(DEFAULT_COLOR);
                }
                else
                    c_printf(symbol[OK_BLK_NDX]);

                x += SIGN_WIDTH;
                if ( x > X_BOUND )
                {
                    y++;
                    x = 3;
                } /* end if */
                
                if ( ++nBox < box_num )
                    c_printXY(x, y, symbol[CHK_BLK_NDX]);

                count = box_side;
            } /* end if */

            /*------ check user press ESC key ------*/
            if ( c_kbhit() && (WaitKey() == ESC_KEY) )
            {
                if ( safeArea )
                    memset(safeArea, 0, sizeof(SafeArea) * SAFE_AREA_NUM);
                User_Interrupt_Box();                    /** ܨϥΪ̤_ **/
                return;
            } /* end if */
        } /* end for side */

        /* show block status -- good/bad/checking */
        if ( bBadCyl || (cyl >= end_cyl) )
        {
            if ( (area.start != -1UL) && safeArea )
            {
                area.nCyls = cyl - area.start + (bBadCyl ? 0 : 1);
                for ( i = 0 ; i < SAFE_AREA_NUM ; i++ )
                    if ( area.nCyls > safeArea[i].nCyls )
                    {
                        for ( j = SAFE_AREA_NUM - 1 ; j > i ; j-- )
                            safeArea[j] = safeArea[j-1];
                        safeArea[j] = area;
                        break;
                    } /* end if */

                area.start = -1UL;
                area.nCyls = 0;
            } /* end if */

            if ( bBadCyl )
            {
                bBadCyl = FALSE;
                nBadCyl++;
            } /* end if */
        }
        else
        {
            if ( area.start == -1UL )
                area.start = cyl;
        } /* end if */
    } /* end for cyl */
    
    /* Sort by start cylinder */
    if ( safeArea )
        for ( i = 0 ; i < SAFE_AREA_NUM - 1 && safeArea[i].nCyls ; i++ )
            for ( j = i+1 ; j < SAFE_AREA_NUM && safeArea[j].nCyls ; j++ )
                if ( safeArea[i].start > safeArea[j].start )
                {
                    area = safeArea[i];
                    safeArea[i] = safeArea[j];
                    safeArea[j] = area;
                } /* end if */

    if ( nBadSide == 0 )
    {
        if ( fptr )
        {
            new_fprintf(fptr, "%s\n", notFoundBad);
            new_fclose(fptr);
        } /* end if */

        Prompt_Msg_Box(notFoundBad, NULL);                   /** ϰϥ` **/
    }
    else
    {
        Beep();
        Warning_Msg_Box(FOUND_BAD_SECT, NULL);             /** laϰϵo{ **/

        /*------ debug code ------*/
        #if 1
            if ( safeArea && safeArea[0].nCyls )
            {
                if ( fptr )
                {
                    double  size;
                    sbyte   *unit;

                    new_fprintf(fptr, "\n\n%s\n", SAFE_AREA_MSG);
                    new_fprintf(fptr, 
                                "%-4s%8s%8s%17s\n",
                                SERNO_TITLE, START_CYL_TITLE, 
                                END_CYL_TITLE, AREA_SIZE_TITLE);
                    for ( i = 0 ; i < 38 ; i++ )
                        new_fputc('-', fptr);
                    for ( i = 0 ; i < SAFE_AREA_NUM && safeArea[i].nCyls ; i++ )
                    {
                        size = (double)(safeArea[i].nCyls) * 
                                       (CUR_DK->lgeo.maxHead + 1) *
                                       (CUR_DK->lgeo.maxSect) / 2.0;
                        size = TranSizeUnit(size, &unit, KB_UNIT);
                        new_fprintf(fptr, 
                                    "\n%2d. %8lu%8lu%14.2f %s ", 
                                    i+1, safeArea[i].start, 
                                    safeArea[i].start + safeArea[i].nCyls - 1, 
                                    size, unit);
                    } /* end if */

                    new_fclose(fptr);
                } /* end if */
                
                UseSafeArea(safeArea);
            } /* end if */
        #else
            c_gotoxy(1,1);
            for ( i = 0 ; i < SAFE_AREA_NUM && safeArea[i].nCyls ; i++ )
                c_printf("--> cyl(%d): %5lu ~ %5lu    \n", 
                         i, safeArea[i].start, safeArea[i].start + safeArea[i].nCyls - 1);
            getchar();
        #endif
    } /* end if */
} /* end Chk_Surface */
