/*----------------------------------------------------------------------------+
|   Copyright (C) 2004  Hsu-Ping Feng                                         |
|                                                                             |
|   This program is free software; you can redistribute it and/or modify      |
|   it under the terms of the GNU General Public License as published by      |
|   the Free Software Foundation; either version 2 of the License, or         |
|   (at your option) any later version.                                       |
|                                                                             |
|   This program is distributed in the hope that it will be useful,           |
|   but WITHOUT ANY WARRANTY; without even the implied warranty of            |
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
|   GNU General Public License for more details.                              |
|                                                                             |
|   You should have received a copy of the GNU General Public License         |
|   along with this program; if not, write to the Free Software               |
|                                                                             |
|   Foundation, Inc., 59 Temple Place, Suite 330,                             |
|   Boston, MA  02111-1307 USA                                                |
|                                                                             |
|   Author e-mail: spferng@ksts.seed.net.tw                                   |
+----------------------------------------------------------------------------*/
#include <stdio.h>
#include <conio.h>
#include "bootmgr.h"
#include "common.h"
#include "output.h"

#if ( LANGUAGE_SELE != CHINESE )
    #define CONTENT_X       (  15)
    #define PMT_BOX_LF_X    (  13)
    #define PMT_BOX_RT_X    (  68)
    #define COPYRIGHT_MSG   "Copyright (C) 2004, Hsu-Ping Feng (S.P.Ferng)"
    #define COPYRIGHT_MSG1  "SPecialFDisk is a freeware, you can redistribute it."
    #define COPYRIGHT_MSG2  "It is not offered for any commercial transaction."
    #define HOMEPAGE_MSG    "Homepage: http://spfdisk.sourceforge.net"
    #define EMAIL_MSG       "E-Mail  : spferng@ksts.seed.net.tw "

    static sbyte *msg[] =
    {
        "\nSPecial FDisk is a boot manager and partition tool!",
        "\nSyntax:  SPFDisk  [/Parameter]\n\n",
        "    /q                  Quiet mode\n",
        "    /mbr                Rebuilt MBR, it is equal to DOS's FDISK /mbr\n",
        "    /undo [filename]    Restore the Backup/UNDO file of SPFDisk\n",
        "    /?                  This help",
        "\n\nPlease read the USERGUID.TXT file.  Ver.%s   Programmer: Hsu-Ping Feng\n"
    }; /* end msg[] declaration */

#elif ( CHINESE_SELE == TRANDITION )
    #define CONTENT_X       (  13)
    #define PMT_BOX_LF_X    (  11)
    #define PMT_BOX_RT_X    (  69)
    #define COPYRIGHT_MSG   "Copyright (C) 2004, Hsu-Ping Feng (S.P.Ferng)"
    #define COPYRIGHT_MSG1  "oO@MKOnAbLӷ~欰UziNƻsδG,"
    #define COPYRIGHT_MSG2  gs_FontCopyRight
    #define HOMEPAGE_MSG    "n魺G http://spfdisk.sourceforge.net"
    #define EMAIL_MSG       "@̫HcG spferng@ksts.seed.net.tw "

    static sbyte gs_FontCopyRight[] = "nϥΤrwo -qѥq- v";
    static sbyte *msg[] =
    {
        "\nSPecial FDisk O@MݨҰʺ޲zεwФγBzKOn I",
        "\nykG  SPFDisk  [/Ѽ]\n\n",
        "    /q                  RҦ\n",
        "    /mbr                s MBRA۷ DOS  FDISK /mbr\n",
        "    /undo [filename]    ^s SPFDisk ƥɩ UNDO \n",
        "    /?                  DUe",
        "\n\nо\\Ū USERGUID.TXT ɡA sG%s   {]pG\n"
    }; /* end msg[] declaration */

#elif ( CHINESE_SELE == SIMPLE )
    #define CONTENT_X       (  13)
    #define PMT_BOX_LF_X    (  11)
    #define PMT_BOX_RT_X    (  69)
    #define COPYRIGHT_MSG   "Copyright (C) 2004, Hsu-Ping Feng (S.P.Ferng)"
    #define COPYRIGHT_MSG1  "oO@MKOnAbLӷ~欰UziNƻsδG,"
    #define COPYRIGHT_MSG2  gs_FontCopyRight
    #define HOMEPAGE_MSG    "n魺G http://spfdisk.sourceforge.net"
    #define EMAIL_MSG       "@̫HcG spferng@ksts.seed.net.tw "

    static sbyte gs_FontCopyRight[] = "nϥΤrwo -qѥq- v";
    static sbyte *msg[] =
    {
        "\nSPecial FDisk O@MݨE޲zεwLϳBzKOn I",
        "\nykG  SPFDisk  [/Ѽ]\n\n",
        "    /q                  RҦ\n",
        "    /mbr                s MBRA۷ DOS  FDISK /mbr\n",
        "    /undo [filename]    ^s SPFDisk ƥɩ UNDO \n",
        "    /?                  DUe",
        "\n\nо\\Ū USERGUID.TXT ɡA sG%s   {]pG\n"
    }; /* end msg[] declaration */

#else
    #error Language configure is not support!!!
#endif

/*=============================== DU ==================================*/
void Show_Help (void)
{
    sword  i;

    #if ( LANGUAGE_SELE == CHINESE )
        c_textattr( YELLOW + (BLUE << 4) );
        c_printf(" %s I", gs_FontCopyRight);
        c_textattr(LIGHTGRAY);
    #endif
 
    for ( i = 0 ; i < sizeof(msg) / sizeof(sbyte *) - 1 ; i++ )
        c_printf(msg[i]);
    c_printf(msg[i], VERSION);
} /* end Show_Help */


/*============================= ܦrv ================================*/
void Show_Copyright (void)
{
    sword  h_line[] = { 11, 14, 0 };

    Square(PMT_BOX_LF_X, 9, PMT_BOX_RT_X, 17, h_line);                           /** e **/
    ShowCenter(10, COPYRIGHT_MSG);
    c_printXY(CONTENT_X, 12, COPYRIGHT_MSG1);

    #if ( LANGUAGE_SELE == CHINESE )
        c_textattr( YELLOW + (BLUE << 4) );
    #endif

    c_printXY(CONTENT_X, 13, COPYRIGHT_MSG2);

    #if ( LANGUAGE_SELE == CHINESE )
        c_textattr(DEFAULT_COLOR);
    #endif

    c_printXY(CONTENT_X, 15, HOMEPAGE_MSG);
    c_printXY(CONTENT_X, 16, EMAIL_MSG);

    WaitKey();
} /* end Show_Copyright */
