/*----------------------------------------------------------------------------+
|   Copyright (C) 2004  Hsu-Ping Feng                                         |
|                                                                             |
|   This program is free software; you can redistribute it and/or modify      |
|   it under the terms of the GNU General Public License as published by      |
|   the Free Software Foundation; either version 2 of the License, or         |
|   (at your option) any later version.                                       |
|                                                                             |
|   This program is distributed in the hope that it will be useful,           |
|   but WITHOUT ANY WARRANTY; without even the implied warranty of            |
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
|   GNU General Public License for more details.                              |
|                                                                             |
|   You should have received a copy of the GNU General Public License         |
|   along with this program; if not, write to the Free Software               |
|                                                                             |
|   Foundation, Inc., 59 Temple Place, Suite 330,                             |
|   Boston, MA  02111-1307 USA                                                |
|                                                                             |
|                                                                             |
|   Author e-mail: spferng@ksts.seed.net.tw                                   |
+----------------------------------------------------------------------------*/
#include <stdio.h>
#include <conio.h>
#include "fdisk.h"
#include "selemenu.h"
#include "output.h"
#include "global.h"
#include "keymap.h"

#if ( LANGUAGE_SELE != CHINESE )
    #define FUNC_NO_IMPLEMENT   "Sorry, The function was incompletion\nin the version!"
    #define SERNO_TITLE         "No."
    #define START_CYL_TITLE     "Start"
    #define END_CYL_TITLE       "End"
    #define AREA_SIZE_TITLE     "Safe_Area_Size"
    #define RUN_CHK_PROC_MSG    "Run after surface test all\ntracks procedure."
    #define CHK_ALL_TRACK_MSG   "1.  Surface test all tracks"
    #define MAKE_SAFE_PARTN_MSG "2.  Display safe partition "

#elif ( CHINESE_SELE == TRANDITION )
    #define FUNC_NO_IMPLEMENT   "|\\C"
    #define SERNO_TITLE         "s"
    #define START_CYL_TITLE     "ҩl"
    #define END_CYL_TITLE       ""
    #define AREA_SIZE_TITLE     "wϰeq"
    #define RUN_CHK_PROC_MSG    "ХҦϭy{ǡC"
    #define CHK_ALL_TRACK_MSG   "1.       ҡ@    y"
    #define MAKE_SAFE_PARTN_MSG "2.   @  w      "

#elif ( CHINESE_SELE == SIMPLE )
    #define FUNC_NO_IMPLEMENT   "|\\C"
    #define SERNO_TITLE         "s"
    #define START_CYL_TITLE     "ҩl"
    #define END_CYL_TITLE       ""
    #define AREA_SIZE_TITLE     "wϰeq"
    #define RUN_CHK_PROC_MSG    "ХҦϭy{ǡC"
    #define CHK_ALL_TRACK_MSG   "1.       ҡ@    y"
    #define MAKE_SAFE_PARTN_MSG "2.   @  w      "

#else
    #error Language configure is not support!!!
#endif


/*=================== Use safe area to create partition =====================*/
sword UseSafeArea (SafeArea *area)
{
    #define MENU_BOX_X      (  20)
    #define MENU_BOX_Y      (   5)
    #define MENU_BOX_WIDTH  (  42)
    
    extern SeleMenu  g_Menu;                               /** ο檫 **/
    double           size;
    sbyte            *pItem, *unit;
    sword            i;
    
    MenuBox(MENU_BOX_X, MENU_BOX_Y, 
            MENU_BOX_X + MENU_BOX_WIDTH - 1,
            MENU_BOX_Y + SAFE_AREA_NUM + 3, 
            NULL);

    c_textattr(PAR_MENU_COLOR);
    c_printXY(MENU_BOX_X + 2, MENU_BOX_Y + 1, 
              "%-4s%8s%8s%17s", 
              SERNO_TITLE, START_CYL_TITLE, END_CYL_TITLE, AREA_SIZE_TITLE);

    c_gotoxy(MENU_BOX_X + 2, MENU_BOX_Y + 2);
    Repeat_Char('-', MENU_BOX_WIDTH - 4);
    
    for ( i = 0 ; i < SAFE_AREA_NUM && area[i].nCyls ; i++ )
    {
        size = (double)(area[i].nCyls) * 
                       (CUR_DK->lgeo.maxHead + 1) *
                       (CUR_DK->lgeo.maxSect) / 2.0;
        size = TranSizeUnit(size, &unit, KB_UNIT);

        pItem = g_Menu.allocItemSpace();
        sprintf(pItem, 
                "%2d. %8lu%8lu%14.2f %s ", 
                i+1, area[i].start, area[i].start + area[i].nCyls - 1, size, unit);
        g_Menu.prompt(MENU_BOX_X + 2, MENU_BOX_Y + i + 3, pItem, TRUE);
        g_Menu.disableCtrl( M_WRAP );
        g_Menu.enableCtrl( M_LOCK | M_ONESELE );
    } /* end for */

    i = g_Menu.select(1);
/*
    if ( g_Menu.lastKey() != ESC_KEY )
        Prompt_Msg_Box(FUNC_NO_IMPLEMENT, NULL);
*/    
    return(0);
} /* end UseSafeArea */


/*===========================================================================*/
int Chk_Surface_Menu (SafeArea *safeArea)
{
    extern SeleMenu g_Menu;
    static sword sele = 1;
    sword  oldsele;
 
    MenuBox(23, 7, 54, 10, NULL);                        /** øsΤ **/

    /*----- ͥο -----*/
    g_Menu.prompt(25, 8, CHK_ALL_TRACK_MSG, TRUE);
    g_Menu.prompt(25, 9, MAKE_SAFE_PARTN_MSG, (sword)safeArea[0].nCyls);

    oldsele = sele;
    g_Menu.enableCtrl(M_WRAP | M_LOCK);
    g_Menu.menuColor(PAR_MENU_COLOR, LIGHT_BAR_COLOR);
    sele = g_Menu.select(sele);
    
    switch( sele )
    {
        case 1:
            SetHotKeySW(F5_KEY, FALSE);                    /** Ȱ F5  **/
            Chk_Surface(0, CUR_DK->lgeo.maxCyl, safeArea);
            SetHotKeySW(F5_KEY, TRUE);                     /** _ F5  **/
            break;

        case 2:
            if ( safeArea[0].nCyls )
                UseSafeArea(safeArea);
            else
                Prompt_Msg_Box(RUN_CHK_PROC_MSG, NULL);
            break;

        default:
            sele = oldsele;
            break;
    } /* end switch */
    
    return(0);
} /* end Chk_Surface_Menu */
